/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __CREATE_H__
#define __CREATE_H__

struct s_archive;
struct s_dico;
struct stat64;

int backup_obj_regfile(struct s_archive *ai, char *relpath, char *fullpath, u64 filesize);
int backup_item_stdattr(struct s_archive *ai, char *root, char *relpath, struct stat64 *statbuf, struct s_dico *d, int *objtype, struct s_dico *dichardlinks, int fsid);
int backup_item_xattr(struct s_archive *ai, char *root, char *relpath, struct stat64 *statbuf, struct s_dico *d);
int backup_file(struct s_archive *ai, char *root, char *relpath, struct stat64 *statbuf, struct s_dico *dichardlinks, int fsid);
int backup_dir(struct s_archive *ai, char *root, char *path, struct s_dico *dichardlinks, u64 dev, int fsid);
int filesystem_prepare_header(struct s_dico *dicofs, char *partition, int fsid);
int filesystem_save(struct s_archive *ai, char *partition, int fsid);
int do_create(char *archive, char **partition, int archtype);
int write_mainhead(struct s_archive *ai, char *label);

#endif // __CREATE_H__
