/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __EXTRACT_H__
#define __EXTRACT_H__

struct s_archive;
struct s_dico;

int restore_obj_hardlink(struct s_archive *ai, char *fullpath, char *destdir, struct s_dico *d);
int restore_obj_symlink(struct s_archive *ai, char *fullpath, char *destdir, struct s_dico *d);
int restore_obj_regfile(struct s_archive *ai, char *relpath, char *fullpath, char *destdir, struct s_dico *d);
int restore_obj_devfile(struct s_archive *ai, char *fullpath, char *destdir, struct s_dico *d);
int restore_object(struct s_archive *ai, int *errors, char *destdir, struct s_dico *dicoattr, int fsid);
int filesystem_extract(struct s_archive *ai, struct s_dico *dicofs, struct s_dico *dicocmdline, int fsid);
int extract_read_objects(struct s_archive *ai, int *errors, char *destdir, int fsid);
int read_mainhead(struct s_archive *ai, struct s_dico **dicomainhead);
int do_extract(char *archive, char *cmdargv[], int oper);

#endif // __EXTRACT_H__
