/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __FS_EXT2_H__
#define __FS_EXT2_H__

struct s_dico;

int ext2_get_specific_features(struct s_dico *d, char *devname);
int ext2_mkfs(struct s_dico *d, char *partition, char *filesystem);

#define E2P_FEATURE_COMPAT      0
#define E2P_FEATURE_INCOMPAT    1
#define E2P_FEATURE_RO_INCOMPAT 2
#define E2P_FEATURE_TYPE_MASK   0x03

#define E2P_FEATURE_NEGATE_FLAG 0x80

#define E2P_FS_FEATURE          0
#define E2P_JOURNAL_FEATURE     1

#endif // __FS_EXT2_H__
