/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008-2009 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __MOUNT_H__
#define __MOUNT_H__

#include <stdio.h>

int get_filesystem_info(char *dev, char *mnt, char *text, int textlen);
int get_filesystem_rw_status(char *options);
int devcmp(char *dev1, char *dev2);
int mount_get_devinfo(char *devname, int *readwrite, char *mntbuf, int maxmntbuf, char *optbuf, int maxoptbuf, char *fsbuf, int maxfsbuf);
int mount_partition(char *partition, char *mntbuf, char *fsbuf, int maxfsbuf, int flags);
int unmount_partition(char *mntbuf);

struct fsmount
{
	const char *filesys;
	const char *mntopt;
};

#endif // __MOUNT_H__
